=== debian/changelog ===
ksnip (1.7.1-1mx19+1) mx; urgency=medium

  * Rebuild for MX-19.

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Sun, 26 Jul 2020 14:33:30 -0700
