## ksnip 1.8.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.5)
-project(ksnip LANGUAGES CXX VERSION 1.7.1)
+project(ksnip LANGUAGES CXX VERSION 1.8.0)
 
 if (DEFINED VERSION_SUFIX AND NOT "${VERSION_SUFIX}" STREQUAL "")
     set(KSNIP_VERSION_SUFIX "-${VERSION_SUFIX}")
@@ -30,15 +30,9 @@
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 set(CMAKE_CXX_EXTENSIONS OFF)
 
-set(QT_MIN_VERSION "5.9.4")
+option(BUILD_TESTS "Build Unit Tests" OFF)
 
-find_package(Qt5 ${QT_MIN_VERSION} REQUIRED Widgets Network Xml PrintSupport DBus Svg)
-
-if (WIN32)
-    find_package(Qt5 ${QT_MIN_VERSION} REQUIRED WinExtras)
-elseif (UNIX AND NOT APPLE)
-    find_package(Qt5 ${QT_MIN_VERSION} REQUIRED X11Extras)
-
+if (UNIX AND NOT APPLE)
     # Without ECM we're unable to load XCB
     find_package(ECM REQUIRED NO_MODULE)
     set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH})
@@ -47,7 +41,22 @@
     find_package(XCB COMPONENTS XFIXES)
 endif ()
 
-set(KIMAGEANNOTATOR_MIN_VERSION "0.3.1")
+set(QT_COMPONENTS Core Widgets Network Xml PrintSupport DBus Svg)
+set(QT_MIN_VERSION 5.9.4)
+
+if (X11_FOUND)
+  list(APPEND QT_COMPONENTS X11Extras)
+elseif (WIN32)
+  list(APPEND QT_COMPONENTS WinExtras)
+endif()
+
+if (BUILD_TESTS)
+  list(APPEND QT_COMPONENTS Test)
+endif()
+
+find_package(Qt5 ${QT_MIN_VERSION} REQUIRED ${QT_COMPONENTS})
+
+set(KIMAGEANNOTATOR_MIN_VERSION "0.4.0")
 find_package(kImageAnnotator ${KIMAGEANNOTATOR_MIN_VERSION} REQUIRED)
 
 set(BASEPATH "${CMAKE_SOURCE_DIR}")
@@ -56,3 +65,11 @@
 add_subdirectory(src)
 add_subdirectory(translations)
 add_subdirectory(desktop)
+
+if (BUILD_TESTS)
+	configure_file(src/BuildConfig.h.in ${CMAKE_CURRENT_BINARY_DIR}/tests/BuildConfig.h)
+
+	enable_testing()
+	add_subdirectory(tests)
+
+endif (BUILD_TESTS)
