=== translations/CMakeLists.txt ===
--- 
+++ 
@@ -20,11 +20,13 @@
 	ksnip_no.ts
 	ksnip_pl.ts
 	ksnip_pt.ts
+	ksnip_pt_BR.ts
 	ksnip_ru.ts
+	ksnip_si.ts
 	ksnip_sv.ts
 	ksnip_tr.ts
 	ksnip_uk.ts
-	ksnip_zh_Hans.ts)
+	ksnip_zh_CN.ts)
 
 if (DEFINED UPDATE_TS_FILES)
 	qt5_create_translation(KSNIP_LANG_QM ${CMAKE_SOURCE_DIR}/translations ${KSNIP_SRCS} ${KSNIP_LANG_TS} OPTIONS "-no-obsolete")
