=== debian/changelog ===
ksnip (1.8.0-2~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Boyuan Yang <byang@debian.org>  Fri, 16 Apr 2021 15:38:35 -0400

ksnip (1.8.0-2) unstable; urgency=medium

  * Rebuild against fixed kimageannotator. 

 -- Boyuan Yang <byang@debian.org>  Sat, 26 Dec 2020 23:54:33 -0500

ksnip (1.8.0-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Thu, 17 Dec 2020 14:40:50 -0500

ksnip (1.7.3-3~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Boyuan Yang <byang@debian.org>  Wed, 07 Oct 2020 14:53:12 -0400

ksnip (1.7.3-3) unstable; urgency=medium

  * Add patch to rename zh_Hans translation to zh_CN to ensure
    proper load on Simplified Chinese platform.

 -- Boyuan Yang <byang@debian.org>  Thu, 01 Oct 2020 18:29:24 -0400

ksnip (1.7.3-2) unstable; urgency=medium

  * Source-only upload for testing migration. 
  * debian/upstream/metadata: Refresh information.

 -- Boyuan Yang <byang@debian.org>  Thu, 01 Oct 2020 09:48:19 -0400

ksnip (1.7.3-1) unstable; urgency=medium

  * Initial release. (Closes: #956496)

 -- Boyuan Yang <byang@debian.org>  Wed, 30 Sep 2020 17:44:47 -0400
