=== debian/control ===
Source: ksnip
Section: graphics
Priority: optional
Maintainer: Boyuan Yang <byang@debian.org>
Standards-Version: 4.5.1
Build-Depends:
 debhelper-compat (= 13),
 qtbase5-dev,
 qttools5-dev,
 cmake,
 extra-cmake-modules,
 libqt5x11extras5-dev,
 libkimageannotator-dev (>= 0.4.0-2~),
 libkcolorpicker-dev (>= 0.1.5~git20201226),
 libqt5svg5-dev,
 libx11-dev,
 libxcb-xfixes0-dev,
Rules-Requires-Root: no
Homepage: https://github.com/ksnip/ksnip
Vcs-Git: https://salsa.debian.org/debian/ksnip.git
Vcs-Browser: https://salsa.debian.org/debian/ksnip.git

Package: ksnip
Architecture: any
Depends:
 libqt5svg5,
 ${shlibs:Depends},
 ${misc:Depends},
Description: Qt-based cross-platform screenshot tool
 Ksnip is a Qt-based cross-platform screenshot tool that provides many
 annotation features for your screenshots. It provides a traditional
 user interface with experimental GNOME/KDE Wayland support.
