## ksnip 1.9.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,8 @@
 cmake_minimum_required(VERSION 3.5)
-project(ksnip LANGUAGES CXX VERSION 1.8.0)
+project(ksnip LANGUAGES CXX VERSION 1.9.0)
 
 if (DEFINED VERSION_SUFIX AND NOT "${VERSION_SUFIX}" STREQUAL "")
-    set(KSNIP_VERSION_SUFIX "-${VERSION_SUFIX}")
+	set(KSNIP_VERSION_SUFIX "-${VERSION_SUFIX}")
 endif()
 
 set(KSNIP_VERSION "${PROJECT_VERSION}${KSNIP_VERSION_SUFIX}")
@@ -33,31 +33,38 @@
 option(BUILD_TESTS "Build Unit Tests" OFF)
 
 if (UNIX AND NOT APPLE)
-    # Without ECM we're unable to load XCB
-    find_package(ECM REQUIRED NO_MODULE)
-    set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH})
+	# Without ECM we're unable to load XCB
+	find_package(ECM REQUIRED NO_MODULE)
+	set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH})
 
-    find_package(X11 REQUIRED)
-    find_package(XCB COMPONENTS XFIXES)
+	find_package(X11 REQUIRED)
+	find_package(XCB COMPONENTS XFIXES)
 endif ()
 
 set(QT_COMPONENTS Core Widgets Network Xml PrintSupport DBus Svg)
 set(QT_MIN_VERSION 5.9.4)
 
+if (UNIX AND NOT APPLE)
+	list(APPEND QT_COMPONENTS Concurrent)
+endif()
+
 if (X11_FOUND)
-  list(APPEND QT_COMPONENTS X11Extras)
+	list(APPEND QT_COMPONENTS X11Extras)
 elseif (WIN32)
-  list(APPEND QT_COMPONENTS WinExtras)
+	list(APPEND QT_COMPONENTS WinExtras)
 endif()
 
 if (BUILD_TESTS)
-  list(APPEND QT_COMPONENTS Test)
+	list(APPEND QT_COMPONENTS Test)
 endif()
 
 find_package(Qt5 ${QT_MIN_VERSION} REQUIRED ${QT_COMPONENTS})
 
-set(KIMAGEANNOTATOR_MIN_VERSION "0.4.0")
+set(KIMAGEANNOTATOR_MIN_VERSION "0.5.0")
 find_package(kImageAnnotator ${KIMAGEANNOTATOR_MIN_VERSION} REQUIRED)
+
+set(KCOLORPICKER_MIN_VERSION "0.1.6")
+find_package(kColorPicker ${KCOLORPICKER_MIN_VERSION} REQUIRED)
 
 set(BASEPATH "${CMAKE_SOURCE_DIR}")
 include_directories("${BASEPATH}")
@@ -71,5 +78,4 @@
 
 	enable_testing()
 	add_subdirectory(tests)
-
 endif (BUILD_TESTS)
