=== src/CMakeLists.txt ===
--- 
+++ 
@@ -20,21 +20,25 @@
 	${CMAKE_SOURCE_DIR}/src/backend/TranslationLoader.cpp
 	${CMAKE_SOURCE_DIR}/src/backend/KsnipCommandLine.cpp
 	${CMAKE_SOURCE_DIR}/src/backend/WatermarkImageLoader.cpp
+	${CMAKE_SOURCE_DIR}/src/backend/recentImages/RecentImagesPathStore.cpp
+	${CMAKE_SOURCE_DIR}/src/backend/recentImages/ImagePathStorage.cpp
 	${CMAKE_SOURCE_DIR}/src/backend/ipc/IpcServer.cpp
 	${CMAKE_SOURCE_DIR}/src/backend/ipc/IpcClient.cpp
 	${CMAKE_SOURCE_DIR}/src/common/adapter/fileDialog/FileDialogAdapter.cpp
-	${CMAKE_SOURCE_DIR}/src/common/adapter/fileDialog/SnapFileDialogAdapter.cpp
 	${CMAKE_SOURCE_DIR}/src/common/adapter/fileDialog/FileDialogAdapterFactory.cpp
 	${CMAKE_SOURCE_DIR}/src/common/helper/MathHelper.cpp
 	${CMAKE_SOURCE_DIR}/src/common/helper/PathHelper.cpp
 	${CMAKE_SOURCE_DIR}/src/common/helper/FileUrlHelper.cpp
 	${CMAKE_SOURCE_DIR}/src/common/helper/RectHelper.cpp
+	${CMAKE_SOURCE_DIR}/src/common/helper/EnumTranslator.cpp
 	${CMAKE_SOURCE_DIR}/src/common/loader/IconLoader.cpp
 	${CMAKE_SOURCE_DIR}/src/common/handler/DelayHandler.cpp
-	${CMAKE_SOURCE_DIR}/src/common/handler/DragAndDropHandler.cpp
 	${CMAKE_SOURCE_DIR}/src/common/provider/ApplicationTitleProvider.cpp
 	${CMAKE_SOURCE_DIR}/src/common/provider/NewCaptureNameProvider.cpp
 	${CMAKE_SOURCE_DIR}/src/common/provider/PathFromCaptureProvider.cpp
+	${CMAKE_SOURCE_DIR}/src/common/provider/DirectoryPathProvider.cpp
+	${CMAKE_SOURCE_DIR}/src/common/provider/ScaledSizeProvider.cpp
+	${CMAKE_SOURCE_DIR}/src/common/provider/TempFileProvider.cpp
 	${CMAKE_SOURCE_DIR}/src/widgets/CustomToolButton.cpp
 	${CMAKE_SOURCE_DIR}/src/widgets/CustomCursor.cpp
 	${CMAKE_SOURCE_DIR}/src/widgets/CursorFactory.cpp
@@ -46,8 +50,12 @@
 	${CMAKE_SOURCE_DIR}/src/widgets/KeySequenceLineEdit.cpp
 	${CMAKE_SOURCE_DIR}/src/widgets/CustomLineEdit.cpp
 	${CMAKE_SOURCE_DIR}/src/gui/MainWindow.cpp
+	${CMAKE_SOURCE_DIR}/src/gui/RecentImagesMenu.cpp
 	${CMAKE_SOURCE_DIR}/src/gui/ImgurHistoryDialog.cpp
 	${CMAKE_SOURCE_DIR}/src/gui/TrayIcon.cpp
+	${CMAKE_SOURCE_DIR}/src/gui/actions/Action.cpp
+	${CMAKE_SOURCE_DIR}/src/gui/actions/ActionProcessor.cpp
+	${CMAKE_SOURCE_DIR}/src/gui/actions/ActionsMenu.cpp
 	${CMAKE_SOURCE_DIR}/src/gui/clipboard/ClipboardAdapter.cpp
 	${CMAKE_SOURCE_DIR}/src/gui/clipboard/IClipboard.h
 	${CMAKE_SOURCE_DIR}/src/gui/imageAnnotator/KImageAnnotatorAdapter.cpp
@@ -65,7 +73,9 @@
 	${CMAKE_SOURCE_DIR}/src/gui/snippingArea/AdornerSizeInfo.cpp
 	${CMAKE_SOURCE_DIR}/src/gui/snippingArea/SnippingAreaResizer.cpp
 	${CMAKE_SOURCE_DIR}/src/gui/snippingArea/SnippingAreaSelector.cpp
-	${CMAKE_SOURCE_DIR}/src/gui/snippingArea/SnippingAreaInfoText.cpp
+	${CMAKE_SOURCE_DIR}/src/gui/snippingArea/SnippingAreaSelectorInfoText.cpp
+	${CMAKE_SOURCE_DIR}/src/gui/snippingArea/SnippingAreaResizerInfoText.cpp
+	${CMAKE_SOURCE_DIR}/src/gui/snippingArea/AbstractSnippingAreaInfoText.cpp
 	${CMAKE_SOURCE_DIR}/src/gui/settingsDialog/AnnotationSettings.cpp
 	${CMAKE_SOURCE_DIR}/src/gui/settingsDialog/ApplicationSettings.cpp
 	${CMAKE_SOURCE_DIR}/src/gui/settingsDialog/ImageGrabberSettings.cpp
@@ -77,11 +87,17 @@
 	${CMAKE_SOURCE_DIR}/src/gui/settingsDialog/StickerSettings.cpp
 	${CMAKE_SOURCE_DIR}/src/gui/settingsDialog/SnippingAreaSettings.cpp
 	${CMAKE_SOURCE_DIR}/src/gui/settingsDialog/SettingsDialog.cpp
+	${CMAKE_SOURCE_DIR}/src/gui/settingsDialog/TrayIconSettings.cpp
+	${CMAKE_SOURCE_DIR}/src/gui/settingsDialog/WatermarkSettings.cpp
+	${CMAKE_SOURCE_DIR}/src/gui/settingsDialog/actions/ActionsSettings.cpp
+	${CMAKE_SOURCE_DIR}/src/gui/settingsDialog/actions/ActionSettingTab.cpp
+	${CMAKE_SOURCE_DIR}/src/gui/settingsDialog/actions/EmptyActionSettingTab.cpp
 	${CMAKE_SOURCE_DIR}/src/gui/aboutDialog/AboutDialog.cpp
 	${CMAKE_SOURCE_DIR}/src/gui/aboutDialog/AboutTab.cpp
 	${CMAKE_SOURCE_DIR}/src/gui/aboutDialog/VersionTab.cpp
 	${CMAKE_SOURCE_DIR}/src/gui/aboutDialog/AuthorTab.cpp
 	${CMAKE_SOURCE_DIR}/src/gui/aboutDialog/DonateTab.cpp
+	${CMAKE_SOURCE_DIR}/src/gui/aboutDialog/ContactTab.cpp
 	${CMAKE_SOURCE_DIR}/src/gui/globalHotKeys/GlobalHotKey.cpp
 	${CMAKE_SOURCE_DIR}/src/gui/globalHotKeys/NativeKeyEventFilter.cpp
 	${CMAKE_SOURCE_DIR}/src/gui/globalHotKeys/AbstractKeyHandler.cpp
@@ -89,6 +105,7 @@
 	${CMAKE_SOURCE_DIR}/src/gui/globalHotKeys/GlobalHotKeyHandler.cpp
 	${CMAKE_SOURCE_DIR}/src/gui/globalHotKeys/HotKeyMap.cpp
 	${CMAKE_SOURCE_DIR}/src/gui/globalHotKeys/DummyKeyHandler.cpp
+	${CMAKE_SOURCE_DIR}/src/gui/notificationService/NotificationServiceFactory.cpp
 	${CMAKE_SOURCE_DIR}/src/gui/operations/SaveOperation.cpp
 	${CMAKE_SOURCE_DIR}/src/gui/operations/RenameOperation.cpp
 	${CMAKE_SOURCE_DIR}/src/gui/operations/AddWatermarkOperation.cpp
@@ -99,6 +116,8 @@
 	${CMAKE_SOURCE_DIR}/src/gui/operations/HandleUploadResultOperation.cpp
 	${CMAKE_SOURCE_DIR}/src/gui/operations/NotifyOperation.cpp
 	${CMAKE_SOURCE_DIR}/src/gui/operations/DeleteImageOperation.cpp
+	${CMAKE_SOURCE_DIR}/src/gui/operations/CopyAsDataUriOperation.cpp
+	${CMAKE_SOURCE_DIR}/src/gui/operations/LoadImageFromFileOperation.cpp
 	${CMAKE_SOURCE_DIR}/src/gui/captureHandler/CaptureTabStateHandler.cpp
 	${CMAKE_SOURCE_DIR}/src/gui/captureHandler/ICaptureTabStateHandler.h
 	${CMAKE_SOURCE_DIR}/src/gui/captureHandler/CaptureHandlerFactory.cpp
@@ -109,6 +128,9 @@
 	${CMAKE_SOURCE_DIR}/src/gui/pinWindow/PinWindowHandler.cpp
 	${CMAKE_SOURCE_DIR}/src/gui/messageBoxService/MessageBoxService.cpp
 	${CMAKE_SOURCE_DIR}/src/gui/serviceLocator/ServiceLocator.cpp
+	${CMAKE_SOURCE_DIR}/src/gui/windowResizer/WindowResizer.cpp
+	${CMAKE_SOURCE_DIR}/src/gui/dragAndDrop/DragAndDropProcessor.cpp
+	${CMAKE_SOURCE_DIR}/src/logging/LogOutputHandler.cpp
 	${CMAKE_SOURCE_DIR}/src/bootstrapper/BootstrapperFactory.cpp
 	${CMAKE_SOURCE_DIR}/src/bootstrapper/StandAloneBootstrapper.cpp
 	${CMAKE_SOURCE_DIR}/src/bootstrapper/singleInstance/InstanceLock.cpp
@@ -118,8 +140,7 @@
 	)
 
 if (APPLE)
-	set(KSNIP_SRCS
-		${KSNIP_SRCS}
+	list(APPEND KSNIP_SRCS
 		${CMAKE_SOURCE_DIR}/src/backend/imageGrabber/MacImageGrabber.cpp
 		${CMAKE_SOURCE_DIR}/src/backend/imageGrabber/MacWrapper.cpp
 		${CMAKE_SOURCE_DIR}/src/backend/config/KsnipMacConfig.cpp
@@ -130,25 +151,28 @@
 		${CMAKE_SOURCE_DIR}/src/common/platform/HdpiScaler.mm
 		)
 elseif (UNIX)
-    set(KSNIP_SRCS
-		${KSNIP_SRCS}
+	list(APPEND KSNIP_SRCS
+		${CMAKE_SOURCE_DIR}/src/backend/imageGrabber/BaseX11ImageGrabber.cpp
 		${CMAKE_SOURCE_DIR}/src/backend/imageGrabber/X11ImageGrabber.cpp
+		${CMAKE_SOURCE_DIR}/src/backend/imageGrabber/GnomeX11ImageGrabber.cpp
 		${CMAKE_SOURCE_DIR}/src/backend/imageGrabber/KdeWaylandImageGrabber.cpp
 		${CMAKE_SOURCE_DIR}/src/backend/imageGrabber/X11Wrapper.cpp
+		${CMAKE_SOURCE_DIR}/src/backend/imageGrabber/GnomeX11Wrapper.cpp
 		${CMAKE_SOURCE_DIR}/src/backend/imageGrabber/GnomeWaylandImageGrabber.cpp
 		${CMAKE_SOURCE_DIR}/src/backend/imageGrabber/WaylandImageGrabber.cpp
 		${CMAKE_SOURCE_DIR}/src/backend/config/KsnipWaylandConfig.cpp
 		${CMAKE_SOURCE_DIR}/src/common/platform/PlatformChecker.cpp
 		${CMAKE_SOURCE_DIR}/src/common/platform/CommandRunner.cpp
+		${CMAKE_SOURCE_DIR}/src/common/adapter/fileDialog/SnapFileDialogAdapter.cpp
 		${CMAKE_SOURCE_DIR}/src/gui/snippingArea/LinuxSnippingArea.cpp
 		${CMAKE_SOURCE_DIR}/src/gui/globalHotKeys/X11KeyHandler.cpp
 		${CMAKE_SOURCE_DIR}/src/gui/globalHotKeys/KeySequenceToX11KeyCodeTranslator.cpp
 		${CMAKE_SOURCE_DIR}/src/gui/globalHotKeys/X11ErrorLogger.cpp
+		${CMAKE_SOURCE_DIR}/src/gui/notificationService/FreeDesktopNotificationService.cpp
 		${CMAKE_SOURCE_DIR}/src/common/platform/HdpiScaler.cpp
 		)
 elseif (WIN32)
-	set(KSNIP_SRCS
-		${KSNIP_SRCS}
+	list(APPEND KSNIP_SRCS
 		${CMAKE_SOURCE_DIR}/src/backend/imageGrabber/WinImageGrabber.cpp
 		${CMAKE_SOURCE_DIR}/src/backend/imageGrabber/WinWrapper.cpp
 		${CMAKE_SOURCE_DIR}/src/gui/snippingArea/WinSnippingArea.cpp
@@ -158,62 +182,23 @@
 		)
 endif ()
 
+# Set the sources variable in the top-level as well, since the tests/
+# directory wants to (re)build as well.
 set(KSNIP_SRCS ${KSNIP_SRCS} PARENT_SCOPE)
 
 if (WIN32)
+	set(CPACK_GENERATOR WIX)
+	set(CPACK_PACKAGE_NAME "ksnip")
+	set(CPACK_PACKAGE_VENDOR "ksnip")
+	set(CPACK_WIX_UPGRADE_GUID "4c7ed545-c0dd-4d45-bf69-c29c7998f668")
+	set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Cross-platform screenshot tool that provides many annotation features for your screenshots.")
+	set(CPACK_PACKAGE_VERSION "${PROJECT_VERSION}")
+	set(CPACK_PACKAGE_INSTALL_DIRECTORY "ksnip")
+	set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/LICENSE.txt")
+	set(CPACK_WIX_PRODUCT_ICON "${CMAKE_SOURCE_DIR}/icons/ksnip.ico")
+
+	INCLUDE(CPack)
+
 	add_executable(ksnip ${KSNIP_SRCS} ${CMAKE_SOURCE_DIR}/icons/ksnip_icons.qrc ${CMAKE_SOURCE_DIR}/icons/ksnip_windows_icon.rc)
 elseif (APPLE)
 	set(MACOSX_BUNDLE_EXECUTABLE_NAME "ksnip")
-	set(MACOSX_BUNDLE_GUI_IDENTIFIER "org.ksnip.ksnip")
-	set(MACOSX_BUNDLE_ICON_FILE "ksnip.icns")
-	set(MACOSX_BUNDLE_INFO_STRING "Cross-Platform Screenshot and Annotation Tool")
-	set(MACOSX_BUNDLE_SHORT_VERSION_STRING ${VERSION})
-	set(MACOSX_BUNDLE_LONG_VERSION_STRING ${KSNIP_VERSION})
-
-	set(MACOSX_ICON ${CMAKE_SOURCE_DIR}/icons/ksnip.icns backend/imageGrabber/AbstractImageGrabber.cpp backend/imageGrabber/AbstractImageGrabber.h)
-	set_source_files_properties(${MACOSX_ICON} PROPERTIES MACOSX_PACKAGE_LOCATION "Resources")
-
-	add_executable(ksnip MACOSX_BUNDLE ${KSNIP_SRCS} ${CMAKE_SOURCE_DIR}/icons/ksnip_icons.qrc ${MACOSX_ICON})
-else()
-	add_executable(ksnip ${KSNIP_SRCS} ${CMAKE_SOURCE_DIR}/icons/ksnip_icons.qrc)
-endif ()
-
-target_link_libraries(ksnip
-					  Qt5::Widgets
-					  Qt5::Network
-					  Qt5::Xml
-					  Qt5::PrintSupport
-					  Qt5::DBus
-					  kImageAnnotator
-					  kColorPicker
-					  Qt5::Svg
-					  )
-
-if (APPLE)
-	target_link_libraries(ksnip "-framework CoreGraphics -framework AppKit")
-elseif (UNIX)
-	target_link_libraries(ksnip
-            Qt5::X11Extras
-			XCB::XFIXES
-            X11
-            )
-elseif(WIN32)
-	target_link_libraries(ksnip
-            Qt5::WinExtras
-            Dwmapi
-			)
-endif ()
-
-if (UNIX AND NOT APPLE)
-	install(TARGETS ksnip RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
-
-    # uninstall target
-    if(NOT TARGET uninstall)
-        configure_file(
-            "${CMAKE_CURRENT_SOURCE_DIR}/../cmake/cmake_uninstall.cmake.in"
-            "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
-            IMMEDIATE @ONLY)
-
-        add_custom_target(uninstall COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
-    endif ()
-endif ()
