=== debian/changelog ===
ksnip (1.9.0-0.1~mx21+1) mx; urgency=medium

  * New upstream release.
  * d/control: bump minver of libkimageannotator-dev to (>= 0.5) and
    libkcolorpicker-dev to (>= 0.1.6).

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 29 May 2021 14:09:06 -0700

ksnip (1.8.2-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Sat, 03 Apr 2021 23:27:27 -0400
