=== debian/control ===
--- 
+++ 
@@ -1,18 +1,19 @@
 Source: ksnip
 Section: graphics
 Priority: optional
-Maintainer: Boyuan Yang <byang@debian.org>
+Maintainer: Steven Pusser <stevep@mxlinux.org>
+XSBC-Original-Maintainer: Boyuan Yang <byang@debian.org>
 Standards-Version: 4.5.1
 Build-Depends:
- debhelper-compat (= 13),
- qtbase5-dev,
- qttools5-dev,
+ debhelper-compat (= 12),
+ qtbase5-dev (>= 5.9.4),
+ qttools5-dev (>= 5.9.4),
  cmake,
  extra-cmake-modules,
- libqt5x11extras5-dev,
- libkimageannotator-dev (>= 0.4.0-2~),
- libkcolorpicker-dev (>= 0.1.5~git20201226),
- libqt5svg5-dev,
+ libqt5x11extras5-dev (>= 5.9.4),
+ libkimageannotator-dev (>= 0.5),
+ libkcolorpicker-dev (>= 0.1.6),
+ libqt5svg5-dev (>= 5.9.4),
  libx11-dev,
  libxcb-xfixes0-dev,
 Rules-Requires-Root: no
