=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%ksnip-$1.tar.gz%" \
 https://github.com/ksnip/ksnip/releases \
 (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
